#version 120

varying vec3 outOrigPos;
varying vec3 outNormal;

uniform sampler3D noiseTex;
//uniform mat4 mvp;
uniform vec4 thrustColor0;
uniform vec4 thrustColor1;
uniform float ticks;

void main()
{
	
	float cosang;
	float edgeAlpha;
	vec4 tc;
	//vec3 Up = normalize(vec3(gl_ModelViewMatrix[0][0],gl_ModelViewMatrix[1][0],gl_ModelViewMatrix[2][0]));
	vec3 Up = normalize(( gl_ModelViewMatrix * vec4(0,0,0,1)).xyz);
	    
	float noiseval;
	
	float heatfactor = thrustColor0.a;

	float heat = 1-clamp((outOrigPos.z/50.0) ,0.001,0.31);
	
	vec2 len = vec2(outOrigPos.y , outOrigPos.x);
	
	heat *= clamp(length(len)/outOrigPos.z*6.7,0.2,1.0);
	
	
	float x= gl_TexCoord[0].x-11 ;
	float y= gl_TexCoord[0].y*5.1+(1)*(5+313*heatfactor);
	float z= ticks;
	//vec4 noise =  texture3D(noiseTex, vec3( x,y,z ) );
	vec4 noise =  texture3D(noiseTex, vec3(gl_TexCoord[0].x,  gl_TexCoord[0].y, 1000 * heatfactor * ticks) );
	noiseval = (noise.x) ;
	
	noiseval = pow(noiseval,0.7+0.04*heatfactor);
	 
	 vec3 a = ( 3*noiseval*pow(heat*heatfactor,1.3)*thrustColor0.rgb);
	 vec3 b = 9.5*noiseval*thrustColor1.rgb;
	tc.rgb = ( a + b ); 
	
	edgeAlpha = abs( dot(Up, outNormal));
	edgeAlpha = max(0.6, edgeAlpha-0.1)*2.5;
	
	//this is very specific to the size of the plum
	//this renders the short plum even if viewer is behind it
	if(length(len) < 0.45 && outOrigPos.z < 0.30){
		edgeAlpha += pow(length(len)/1.9,4.3);
	}
	
	tc.a = (edgeAlpha) * pow(heat, 1.6 + 1.8*(0.8-heatfactor));
	if(tc.a <= 0.001){
		discard;
	}
	
	tc.a -= (1.0 - heatfactor) * 3.37;
	
	gl_FragColor = tc*0.9;
	//gl_FragColor = vec4(outNormal,1);//tc;
}





   